require "go.app.ServerApp"
require "OmokProtocol"

require "OmokUtil"

class 'OmokServerApp' (ServerApp)

function OmokServerApp:__init()	super()	
	math.randomseed(os.time())
	self:initHandler()
	self.ready = false
	self.board = {}
	self.currentColor = 1
	self.isStart = false

	self.omokUtil = OmokUtil()
end
---------------------------------------------------------
-- Server Init
---------------------------------------------------------
function OmokServerApp:initHandler()
	self:SetMsgHandler(Evt_Chat, self.onChat)
	self:SetMsgHandler(Evt_Start, self.onStart)
	self:SetMsgHandler(Evt_Ready, self.onReady)
	self:SetMsgHandler(Evt_Put, self.onPut)
end

---------------------------------------------------------
-- Game Handler
---------------------------------------------------------
function OmokServerApp:OnEnterPlayer(player)
	if player.no == 1 then
		self.player1 = player
	else
		self.player2 = player
	end
end

function OmokServerApp:OnLeavePlayer(player)
		
end

---------------------------------------------------------
-- Network Handler
---------------------------------------------------------
-- 채팅메세지 전송 시
function OmokServerApp:onChat(clientProxy, msg)
	self:SendToAll(msg)
end

-- 시작 요청 시
function OmokServerApp:onStart(clientProxy, msg)
	print("onStart")
	if self.isStart then
		return
	end
	if self.isReady then
		--오목판 초기화
		self:initOmok()
		self:SendToAll(msg)
	else
		local msgChat = Message(Evt_Chat)
		msgChat:SetValue(Evt_Chat.key.chattext, "상대방이 준비를 하지 않았습니다")
		self:SendToAll(msgChat, player2)
	end
end

-- 준비 요청 시
function OmokServerApp:onReady(clientProxy, msg)
	print("onReady")
	self.isReady = true
end

-- 두기
function OmokServerApp:onPut(clientProxy, msg)
	if self.isStart then
		local color = msg:GetValue(Evt_Put.key.color)
		local x = msg:GetValue(Evt_Put.key.x)
		local y = msg:GetValue(Evt_Put.key.y)
		
		if self.board[x][y] > 0 then 
			print("이미있음")
			return 
		else
			print("없음")
		end
		if color == self.currentColor then
			-- 이겼는지 판단
			self.board[x][y] = color;
			local isWin = self.omokUtil:validateWin(self.board, x, y, color)
			if isWin then
				print(color .. "가 이겼음")
				self.isStart = false
				self.isReady = false
				
				local winner = self.player1;
				local loser = self.player2;
				if color == 2 then
					winner = self.player2
					loser = self.player1
				end
				local msgChat = Message(Evt_Chat)
				msgChat:SetValue(Evt_Chat.key.chattext, "당신이 이겼습니다")
				self:SendToAll(msgChat, loser)
				msgChat:SetValue(Evt_Chat.key.chattext, "당신이 졌습니다")
				self:SendToAll(msgChat, winner)
			else
				print("계속 두세요")
			end
			self:SendToAll(msg)
			self.currentColor = (self.currentColor % 2) + 1
		else
			print("당신차례아님")
		end
	end
end

---------------------------------------------------------
-- Omok Handler
---------------------------------------------------------
function OmokServerApp:initOmok()
	self.currentColor = 1
	self.isStart= true

	for i = 0, 14 do
		self.board[i] = {}
		for j = 0, 14 do
			self.board[i][j] = 0
		end
	end
end
